from unittest import TestCase
from thespian.actors import requireCapability

class TestRequireCapability(TestCase):
    @requireCapability('asdf')
    class req1: pass
    def test_oneReq(self):
        self.assertFalse(TestRequireCapability.req1.actorSystemCapabilityCheck({}, 0))
        self.assertFalse(TestRequireCapability.req1.actorSystemCapabilityCheck({'asdf':False}, 0))
        self.assertTrue(TestRequireCapability.req1.actorSystemCapabilityCheck({'asdf':True}, 0))
        self.assertTrue(TestRequireCapability.req1.actorSystemCapabilityCheck({'asdf':True,'qwer':False}, 0))
        self.assertTrue(TestRequireCapability.req1.actorSystemCapabilityCheck({'asdf':True,'qwer':True}, 0))
        self.assertTrue(TestRequireCapability.req1.actorSystemCapabilityCheck({'qwer':False,'asdf':True}, 0))
        self.assertTrue(TestRequireCapability.req1.actorSystemCapabilityCheck({'qwer':True,'asdf':True}, 0))
        self.assertFalse(TestRequireCapability.req1.actorSystemCapabilityCheck({'qwer':False,'asdf':False}, 0))
        self.assertFalse(TestRequireCapability.req1.actorSystemCapabilityCheck({'qwer':True,'asdf':False}, 0))
    @requireCapability('asdf')
    @requireCapability('qwer')
    class req2: pass
    def test_twoReq(self):
        self.assertFalse(TestRequireCapability.req2.actorSystemCapabilityCheck({}, 0))
        self.assertFalse(TestRequireCapability.req2.actorSystemCapabilityCheck({'asdf':False}, 0))
        self.assertFalse(TestRequireCapability.req2.actorSystemCapabilityCheck({'asdf':True}, 0))
        self.assertFalse(TestRequireCapability.req2.actorSystemCapabilityCheck({'asdf':True,'qwer':False}, 0))
        self.assertTrue(TestRequireCapability.req2.actorSystemCapabilityCheck({'asdf':True,'qwer':True}, 0))
        self.assertFalse(TestRequireCapability.req2.actorSystemCapabilityCheck({'qwer':False,'asdf':True}, 0))
        self.assertTrue(TestRequireCapability.req2.actorSystemCapabilityCheck({'qwer':True,'asdf':True}, 0))
        self.assertFalse(TestRequireCapability.req2.actorSystemCapabilityCheck({'qwer':False,'asdf':False}, 0))
        self.assertFalse(TestRequireCapability.req2.actorSystemCapabilityCheck({'qwer':True,'asdf':False}, 0))
    @requireCapability('qwer')
    @requireCapability('asdf')
    class req2rev: pass
    def test_twoReqReverse(self):
        self.assertFalse(TestRequireCapability.req2rev.actorSystemCapabilityCheck({}, 0))
        self.assertFalse(TestRequireCapability.req2rev.actorSystemCapabilityCheck({'asdf':False}, 0))
        self.assertFalse(TestRequireCapability.req2rev.actorSystemCapabilityCheck({'asdf':True}, 0))
        self.assertFalse(TestRequireCapability.req2rev.actorSystemCapabilityCheck({'asdf':True,'qwer':False}, 0))
        self.assertTrue(TestRequireCapability.req2rev.actorSystemCapabilityCheck({'asdf':True,'qwer':True}, 0))
        self.assertFalse(TestRequireCapability.req2rev.actorSystemCapabilityCheck({'qwer':False,'asdf':True}, 0))
        self.assertTrue(TestRequireCapability.req2rev.actorSystemCapabilityCheck({'qwer':True,'asdf':True}, 0))
        self.assertFalse(TestRequireCapability.req2rev.actorSystemCapabilityCheck({'qwer':False,'asdf':False}, 0))
        self.assertFalse(TestRequireCapability.req2rev.actorSystemCapabilityCheck({'qwer':True,'asdf':False}, 0))